using System;
using System.Collections;
using System.IO;
using System.Text;
using System.Configuration;
using System.Reflection;
using System.CodeDom;
using System.CodeDom.Compiler;
using Microsoft.CSharp;

namespace wabi {
	public class Plugin {
		private Assembly asm;
		private ArrayList	plugins = new ArrayList();

		public Plugin() {
			asm = Assembly.GetEntryAssembly();
		}

		private Assembly Compile(string file) {
			// C#RpC쐬
			ICodeCompiler cc = new CSharpCodeProvider().CreateCompiler();
			CompilerParameters cp = new CompilerParameters();
			// AZu̎QƂݒ
			cp.ReferencedAssemblies.AddRange(
				new string[] {"mscorlib.dll","System.dll", asm.Location});
			// ŃRpC
			cp.GenerateInMemory = false;
			CompilerResults cr = cc.CompileAssemblyFromFile(cp, file);
			if(cr.Errors.HasErrors) {
				for (int i = 0; i < cr.Errors.Count; ++i) {
					CompilerError e = cr.Errors[i];
					Console.WriteLine(e.ToString());
				}
				return null;
			}
			return cr.CompiledAssembly;
		}

		public void Load() {
			string baseDir = Path.GetDirectoryName(asm.Location);
			string path = Path.Combine(baseDir, ConfigurationSettings.AppSettings["Plug-in Path"]);
			if (!Directory.Exists(path))
				return;
			foreach (string file in Directory.GetFiles(path, "*.cs")) {
				Assembly a = Compile(file);
				if (a != null) {
					foreach (Type t in a.GetTypes()) {
						FileType ft = a.CreateInstance(t.FullName) as FileType;
						if (ft != null)
							plugins.Add(ft);
					}
				}
			}
		}

		public FileType this[int index] {
			get { return plugins[index] as FileType; }
		}

		public int Count {
			get { return plugins.Count; }
		}
	}

	public delegate void FileFoundHandler(long pos, int len);

	public abstract class FileType {
		public event FileFoundHandler FileFound;
		protected byte[] key;
		protected string ext;

		public byte[] Key {
			get { return key; }
			set { key = value; }
		}

		public string FileExt {
			get { return ext; }
			set { ext = value; }
		}

		public virtual void OnFileFound(long pos, int len) {
			if (FileFound != null)
				FileFound(pos, len);
		}

		public abstract void DoIt(string pathName);
	}
}

